Subject: [v6ops] IPv6 addressing: Gaps? (draft-gont-v6ops-ipv6-addressing-considerations)

From: Fernando Gont <[email-masked]>
Date: Fri, 12 Feb 2021 18:50:48 -0300

Folks,

In the aforementioned document 
(https://tools.ietf.org/html/draft-gont-v6ops-ipv6-addressing-considerations), 
we have tried to do at least three things:

1) Look at what we have and try to discuss things from an architectural
    perspective

2) Analyze the implications of #1 (whether operations, security,
    privacy, etc.)

3) Find missing gaps that currently prevent us from fully leveraging
    IPv6 addressing.

Part of what we've found as doing #3 above is that:

   * There are shortcomings associated with the current APIs that prevent
     better usage of IPv6 addresses

   * Multi-router/multi-prefix routing seems to be broken.
     RFC8028 would be a fundamental starting point in the right
     direction... but I believe there's more to do in this area.

In that light, we'd like to hear further comments on our document. And, 
in particular, we're interested to hear if :

   * there are any operational implications of IPv6 addressing that we
     have missed, or,

   * there's anything related to IPv6 addressing that you consider to
     be currently broken or problematic, that is missing in our I-D.

Thoughts on the current contents of the I-D are, of course, also very 
welcome!

Thanks,
-- 
Fernando Gont
SI6 Networks
e-mail: [email-masked]
PGP Fingerprint: 6666 31C6 D484 63B2 8FB1 E3C4 AE25 0D55 1D4E 7492

---

From: Ted Lemon <[email-masked]>
Date: Thu, 18 Feb 2021 16:16:44 -0500

This is wrong:

   Therefore, ULAs are not globally meaningful and thus, for most (if
   not all) practical purposes, ULAs can be considered to have non-
   global scope.  For this reason, ULAs are treated as non-global scope
   addresses, even when from a specifications point of view they have
   global scope.

ULAs are explicitly global in scope. Please don’t try to change this in an informational document. The other text in this section is fine.

> On Feb 12, 2021, at 4:50 PM, Fernando Gont <[email-masked]> wrote:
> 
> Folks,
> 
> In the aforementioned document (https://tools.ietf.org/html/draft-gont-v6ops-ipv6-addressing-considerations), we have tried to do at least three things:
> 
> In that light, we'd like to hear further comments on our document. And, in particular, we're interested to hear if :
> 
> Thoughts on the current contents of the I-D are, of course, also very welcome!
> 
> Thanks,
> -- 
> Fernando Gont
> SI6 Networks
> _______________________________________________
> v6ops mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/v6ops

---

From: Fernando Gont <[email-masked]>
Date: Thu, 18 Feb 2021 18:32:19 -0300

Ted,

On 18/2/21 18:16, Ted Lemon wrote:
> ULAs are explicitly global in scope. Please don’t try to change this in 
> an informational document. The other text in this section is fine.

FWIW, the intent in this Section wasn't to change that.  The text was 
meant that, when discussing how "scope" affects other properties of IPv6 
addresses, for all practical purposes ULAs have limited scope.

This text predates draft-gont-6man-ipv6-ula-scope which effectively does 
try to formally update the scope of ULAs.

P.S.: I will update the text before the cut-off.

Thanks,

---

From: Ted Lemon <[email-masked]>
Date: Thu, 18 Feb 2021 16:53:00 -0500

On Feb 18, 2021, at 4:32 PM, Fernando Gont <[email-masked]> wrote:
> This text predates draft-gont-6man-ipv6-ula-scope which effectively does try to formally update the scope of ULAs.

I know you haven’t asked for a call for adoption yet, but it’s pretty clear that you’re in the rough on adding a “local” scope. I would hope that the working group would not adopt this document.

---

From: Fernando Gont <[email-masked]>
Date: Thu, 18 Feb 2021 19:09:54 -0300

Hi, Ted,

On 18/2/21 18:53, Ted Lemon wrote:
> On Feb 18, 2021, at 4:32 PM, Fernando Gont <[email-masked] 
> <mailto:[email-masked]>> wrote:
>> This text predates draft-gont-6man-ipv6-ula-scope which effectively 
>> does try to formally update the scope of ULAs.
> 
> I know you haven’t asked for a call for adoption yet, but it’s pretty 
> clear that you’re in the rough on adding a “local” scope

The intent was not to add a local scope, but to fix the inconsistency 
among RFC4291, RFC4193, and RFC4007.

It could very well mean adding a local scope (even if it's ULA 
specific), obsoleting RFC4007, or any other option.

Right now, the "IPv6 Scoped Addressing Architecture" (RFC4007) disagress 
with the definition of ULAs as "global scope" (as per RFC4193/RFC4291).

Yes, networks do not break down as a result of this (it's unlikely that 
that might happen as a result of an architecture document which, by 
definition, it's going to be rather abstract).

But we already have existing cases (e.g. Python's library) where they 
solve our spec inconsistencies in their own way. And, certainly, we 
cannot really offer authoritative responses, because we have different 
specs arguing in different ways.

Given that we'll likely have IPv6 for a while, I would understand if 
people have different ideas regarding how inconsistencies can be solved 
(e.g. "new scope" vs "obsolete RFC4007"). But IMHO it would be awkward 
for folks to argue in favor of keeping conflicting specs.

Thanks,

---

From: Ted Lemon <[email-masked]>
Date: Thu, 18 Feb 2021 17:19:52 -0500

Neither of those are good options. We’ve discussed this ad nauseum. RFC 4007 is correct. We do not need a new scope. A document that addressed this problem would be almost completely different. This is not a good starting place. 

> On Feb 18, 2021, at 17:10, Fernando Gont <[email-masked]> wrote:
> 
> Hi, Ted,
> 
>>> On Feb 18, 2021, at 4:32 PM, Fernando Gont <[email-masked] <mailto:[email-masked]>> wrote:
>> I know you haven’t asked for a call for adoption yet, but it’s pretty clear that you’re in the rough on adding a “local” scope
> 
> The intent was not to add a local scope, but to fix the inconsistency among RFC4291, RFC4193, and RFC4007.
> 
> It could very well mean adding a local scope (even if it's ULA specific), obsoleting RFC4007, or any other option.
> 
> Right now, the "IPv6 Scoped Addressing Architecture" (RFC4007) disagress with the definition of ULAs as "global scope" (as per RFC4193/RFC4291).
> 
> Yes, networks do not break down as a result of this (it's unlikely that that might happen as a result of an architecture document which, by definition, it's going to be rather abstract).
> 
> But we already have existing cases (e.g. Python's library) where they solve our spec inconsistencies in their own way. And, certainly, we cannot really offer authoritative responses, because we have different specs arguing in different ways.
> 
> Given that we'll likely have IPv6 for a while, I would understand if people have different ideas regarding how inconsistencies can be solved (e.g. "new scope" vs "obsolete RFC4007"). But IMHO it would be awkward for folks to argue in favor of keeping conflicting specs.
> 
> Thanks,
> -- 
> Fernando Gont
> SI6 Networks

---

From: Fernando Gont <[email-masked]>
Date: Thu, 18 Feb 2021 19:30:48 -0300

> Neither of those are good options. We’ve discussed this ad nauseum. RFC 4007 is correct. We do not need a new scope. A document that addressed this problem would be almost completely different. Thi…

As far as I understand, the arguments have been:

The "no problem version":

1) "oh yeah, the specs are inconsistent, but we all know what we mean 
with the definition of ULAs", or,

2) Arguments about "scope" actually meaning something different than
   what's in RFC4007

The "there's a problem version":

3) Introduce a new scope, and redefine ULAs as such

4) Change the definition of scope

So... what do you think is the best way to address the inconsistency we 
currently have?  Update what, and how?

As noted, I don't care about any specific outcome, as long as 
inconsistencies are removed.

P.S.: It has also been argued that other special addesses are not really 
"global scope", and such should probably also be re-classified.

Thanks,